Program grafica2;
uses crt,graph;
type tta=array [0..2000] of integer;
     tre=array [0..2000,1..2] of real;
var ta:tta;
    re:tre;
    mini,maxi,aux,x,y,paso,menor,mayor:real;
    errcode,i,grdriver,grmode:integer;
    s:string;

{Procedure funcion(x:real;var y:real);
    begin
       y:=x*x*x
    end;}

Procedure funcion(s:string;x:real;var y:real);
var aux: string;
    i, pare_abi, pare_cer: byte;

Procedure calculo
         (s:string; var k:byte; var resultado:real); forward;

Procedure error(s:string; i:byte);
var j:byte;
begin {write('ERROR: ');
      {for j:=1 to i-1 do write(s[j]);
      {textcolor(18); write(s[i]); textcolor(7);
      for j:=i+1 to length(s) do write(s[j]);
      write; readln;}
      outtext(s);HALT
end;

Procedure calculo_elemento(s:string; var k:byte; var ele:real);
var peso: real;
    v: boolean;
    kr: byte;
    f3: string[3];
begin
 v:=true; ele:=0; kr:=length(s)-k+1;
 if kr>2 then f3:=s[k]+s[k+1]+s[k+2];
 case s[k] of
   'X': begin ele:=x; inc(k); v:= false end;
   '(': begin inc(k); calculo(s,k,ele); v:=false end;
   'A': if kr>3 then if f3+s[k+3]='ABS(' then begin
           inc(k,4); calculo(s,k,ele); ele:=ABS(ele); v:=false end
        else if kr>6 then
        if f3+s[k+3]+s[k+4]+s[k+5]+s[k+6]='ARCTAN(' then begin
           inc(k,7); calculo(s,k,ele); ele:=ARCTAN(ele); v:=false end;
   'C': if kr>3 then if f3+s[k+3]='COS(' then begin
           inc(k,4); calculo(s,k,ele); ele:=COS(ele); v:=false end;
   'E': if kr>3 then if f3+s[k+3]='EXP(' then begin
           inc(k,4); calculo(s,k,ele); ele:=EXP(ele); v:=false end;
   'I': if kr>3 then if f3+s[k+3]='INT(' then begin
           inc(k,4); calculo(s,k,ele); ele:=INT(ele); v:=false end;
   'F': if kr>4 then if f3+s[k+3]+s[k+4]='FRAC(' then begin
           inc(k,5); calculo(s,k,ele); ele:=FRAC(ele); v:=false end;
   'L': if kr>2 then if f3='LN(' then begin
           inc(k,3); calculo(s,k,ele); ele:=LN(ele); v:=false end;
   'S': if (kr>3) and (f3+s[k+3]='SIN(') then begin
           inc(k,4); calculo(s,k,ele); ele:=SIN(ele); v:=false end
        else if (kr>4) and (f3+s[k+3]+s[k+4]='SQRT(') then begin
           inc(k,5); calculo(s,k,ele); ele:=SQRT(ele); v:=false end
        else if (kr>3) and (f3+s[k+3]='SQR(') then begin
           inc(k,4); calculo(s,k,ele); ele:=SQR(ele); v:=false end;
   '0'..'9','.':  begin  peso:=1; v:=false;
     while (k<=length(s)) and (not(s[k] in ['+','-','*','/',')','('])) do
      begin
       if s[k] in ['0'..'9','.'] then
           if s[k]='.' then
             peso:=peso/10
            else
             if peso=1 then
               ele:=ele*10+ord(s[k])-48
              else
               begin
                 ele:=ele+(ord(s[k])-48)*peso;
                 peso:=peso/10
               end
        else error(s+'(de elemento)',k);
       inc(k)
      end  end;
   else error(s+'(de elemento)',k);
 end;
 if v then error(s+' ELEMENTO VACIO',k)
end;

Procedure calculo_factor(s:string; var k:byte; var factor:real);
var elemento: real;
    koperador: byte;
begin
    calculo_elemento(s, k, elemento);
    factor:=elemento;
    while (k<=length(s)) and (not(s[k] in ['+','-','/',')'])) do begin
        koperador:=k;
        if (s[k]+s[k+1])='**' then begin
             inc(k,2); calculo_elemento(s, k, elemento);
             if factor>0 then factor:=exp(elemento*ln(factor))
                else error(s+' BASE DE POTENCIA NEGATIVA',koperador)
            end
        else if s[k]='*' then exit
                         else error(s+'(de factor)',koperador);
    end
end;

Procedure calculo_termino(s:string; var k:byte; var termino:real);
var factor: real;
    koperador: byte;
begin
   calculo_factor(s, k, factor);
   termino:= factor;
   while (k<=length(s)) and (not(s[k] in ['+','-',')'])) do begin
      koperador:=k;
      inc(k); calculo_factor(s, k, factor);
      case s[koperador] of
         '*': termino:=termino*factor;
         '/': if factor<>0 then termino:=termino/factor
                           else error(s+' DIVISION NULA ', koperador);
         else error(s+'(de termino)',koperador)
      end
   end
end;

Procedure calculo(s:string; var k:byte; var resultado:real);
var termino, signo: real;
    koperador: byte;
begin
   signo:=1;
   if s[k]='+' then inc(k);
   if s[k]='-' then begin inc(k); signo:=-1 end;
   calculo_termino(s, k, termino);
   resultado:=signo*termino;
   while (k<=length(s)) and (s[k]<>')') do begin
      koperador:=k;
      inc(k); calculo_termino(s, k, termino);
      case s[koperador] of
        '+': resultado:=resultado+termino;
        '-': resultado:=resultado-termino;
        else error(s+'(de expresion)',koperador)
      end
   end;
   inc(k)
end;

Begin (************************ FUNCION *******************************)
   aux:='';
   for i:=1 to length(s) do begin
      if s[i]<>' ' then aux:=aux+upcase(s[i]);
      if s[i]='(' then inc(pare_abi);
      if s[i]=')' then inc(pare_cer)
     end;
   s:=aux;
   if pare_abi<>pare_cer then  error('Parentesis desbalanceados',1);
   i:=1;
   calculo(s, i, y)
end;

begin  (******************** PRINCIPAL *******************************)
   write('Funcion: '); readln(s);
   write('Desde:   '); readln(mini);
   write('  Hasta: '); readln(maxi);
   grdriver:=detect;
   initgraph(grdriver,grmode,'\tp70\bgi\');
   errcode:=graphresult;
   if errcode<>grOk then begin
             writeln('Error para salir: ',grapherrormsg(errcode));
             readln; halt(1)
       end;
   cleardevice;
   outtext('Ah vamos');
   if mini>maxi then begin aux:=mini; mini:=maxi; maxi:=aux end;
   paso:=(maxi-mini)/getmaxx;
   for i:=0 to getmaxx do begin
      x:=mini+paso*i; re[i,1]:=x;
      if x=0 then line(i,0,i,getmaxy);
      if (i>0) and ((re[i-1,1]*x)<0) then line(i,0,i,getmaxy);
      funcion(s,x,y); re[i,2]:=y end;
   menor:=re[0,2];mayor:=re[0,2];
   for i:=1 to getmaxx do if re[i,2]>mayor then mayor:=re[i,2]
                        else if re[i,2]<menor then menor:=re[i,2];
   if menor=mayor then mayor:=menor+1;
   if menor*mayor<=0 then begin
       i:=round(mayor/(mayor-menor)*getmaxy);
       line(0,i,getmaxx,i) end;
   for i:=0 to getmaxx do
      ta[i]:=(round((re[i,2]-menor)*getmaxy/(mayor-menor))-getmaxy)*(-1);
   for i:=0 to getmaxx do begin putpixel(i,ta[i],3) end;
   repeat until readkey<>'';
   closegraph
end.


